/* acconfig.h
   This file is in the public domain.

   Descriptive text for the C preprocessor macros that
   the distributed Autoconf macros can define.
   No software package will use all of them; autoheader copies the ones
   your configure.in uses into your configuration header file templates.

   The entries are in sort -df order: alphabetical, case insensitive,
   ignoring punctuation (such as underscores).  Although this order
   can split up related entries, it makes it easier to check whether
   a given entry is in the file.

   Leave the following blank line there!!  Autoheader needs it.  */


/* Version of .frm files */
#undef DOT_FRM_VERSION

/* READLINE: */
#undef FIONREAD_IN_SYS_IOCTL

/* READLINE: Define if your system defines TIOCGWINSZ in sys/ioctl.h.  */
#undef GWINSZ_IN_SYS_IOCTL

/* bool is not defined by all C++ compilators */
#undef HAVE_BOOL

/* READLINE: */
#undef HAVE_BSD_SIGNALS

/* READLINE: */
#undef HAVE_GETPW_DECLS

/* Define is we have GNU readline */
#undef HAVE_LIBREADLINE

/* Define if we are using Xavier Leroy's LinuxThreads */
#undef HAVE_LINUXTHREADS

/* Do we use user level threads */
#undef HAVE_mit_thread

/* READLINE: */
#undef HAVE_POSIX_SIGNALS

/* Solaris define gethostbyaddr_r with 7 arguments. glibc2 defines
   this with 8 arguments */
#undef HAVE_SOLARIS_STYLE_GETHOST

/* MIT pthreads does not support connecting with unix sockets */
#undef HAVE_THREADS_WITHOUT_SOCKETS

/* Timespec has a ts_sec instead of tv_sev  */
#undef HAVE_TIMESPEC_TS_SEC

/* Define if the system files define uchar */
#undef HAVE_UCHAR

/* Define if the system files define ulong */
#undef HAVE_ULONG

/* READLINE: */
#undef HAVE_USG_SIGHOLD

/* Define to machine type name eg sun10 */
#undef MACHINE_TYPE

/* READLINE: no sys file*/
#undef NO_SYS_FILE

/* Program name */
#undef PACKAGE

/* mysql client protocoll version */
#undef PROTOCOL_VERSION

/* Define if qsort returns void */
#undef QSORT_TYPE_IS_VOID

/* Define as the return type of qsort (int or void). */
#undef RETQSORTTYPE

/* Define as the base type of the last arg to accept */
#undef SOCKET_SIZE_TYPE

/* READLINE: */
#undef STRUCT_DIRENT_HAS_D_INO

/* Define to name of system eg solaris*/
#undef SYSTEM_TYPE

/* Define if you want to have threaded code. This may be undef on client code */
#undef THREAD

/* READLINE: */
#undef TIOCSTAT_IN_SYS_IOCTL

/* Program version */
#undef VERSION

/* READLINE: */
#undef VOID_SIGHANDLER


/* Leave that blank line there!!  Autoheader needs it.
   If you're adding to this file, keep in mind:
   The entries are in sort -df order: alphabetical, case insensitive,
   ignoring punctuation (such as underscores).  */
