#!@PERL@             
# ****************************
# static information...
	$VERSION = "1.2-3a, 16 Jun 1997";
        $0       =~ m%/([^/]+)$%o;
        $script  = $1;
        $script = 'mysqlaccess' unless $script;

$INFO = <<"_INFO";
--------------------------------------------------------------------------
   mysqlaccess (Version $VERSION)
   ~~~~~~~~~~~
   Copyright (C) 1997 Yves.Carlier\@rug.ac.be
                      University of Ghent (RUG), Belgium
                      Administratieve Informatieverwerking (AIV)

   report the access-privileges for a USER from a HOST to a DB

   Many thanks go to <monty\@tcx.se> and <psmith\@BayNetworks.COM>
   for their suggestions, debugging and patches. 

   use `$script -?' to get more information on available options.

--------------------------------------------------------------------------
_INFO

$OPTIONS = <<_OPTIONS;

Usage: $script [host] [user] [db] OPTIONS

  -?, --help           display this helpscreen and exit
  -v, --version        print information on the program `$script'

  -u, --user=#         username for logging in to the db
  -p, --password=#     validate password for user
  -h, --host=#         name or IP-number of the host
  -d, --db=#           name of the database

  -U, --superuser=#    connect as superuser
  -P, --spassword=#    password for superuser
  -H, --rhost=#        remote MySQL-server to connect to

  -b, --brief          single-line tabular report

  --relnotes           print release-notes
  --plan               print suggestions/ideas for future releases
  --howto              some examples of how to run `$script'
  --debug=N            enter debuglevel N (0..3)

  Note:
    + At least the user and the db must be given (even with wildcards)
    + If no host is given, `localhost' is assumed
    + Wilcards (*,?,%,_) are allowed for host, user and db, but be sure 
      to escape them from your shell!! (ie type \\* or '*')
_OPTIONS

$RELEASE = <<'_RELEASE';
 
Release Notes:
-------------
  0.1-beta1: internal
  - first trial.
 
  0.1-beta2: (1997-02-27)
  - complete rewrite of the granting-rules, based on the documentation
    found in de FAQ.
  - IP-number and name for a host are equiv.
 
  0.1-beta3: (1997-03-10)
  - more information on the rules which are used.
  - 'localhost' and the name/ip of the local machine are now equiv.

  0.1-beta4: (1997-03-11)
  - inform the user if he has not enough priv. to read the mysql db

  1.0-beta1: (1997-03-12)
  suggestions by Monty:
  - connect as superuser with superpassword.
  - mysqlaccess could also notice if all tables are empty. This means
    that all user have full access!
  - It would be nice if one could optionally start mysqlaccess without
    any options just the arguments 'user db' or 'host user db', where
    host is 'localhost' if one uses only two arguments.

  1.0-beta2: (1997-03-14)
  - bugfix: translation to reg.expr of \_ and \%.
  - bugfix: error in matching regular expression and string given
            by user which resulted in
            'test_123' being matched with 'test'

  1.0-beta3: (1997-03-14)
  - bugfix: the user-field should not be treated as a sql-regexpr,
            but as a plain string.
  - bugfix: the host-table should not be used if the host isn't empty in db
                                          or  if the host isn't emty in user
            (Monty)
 
  1.0-beta4: (1997-03-14)
  - bugfix: in an expression "$i = $j or $k", the '=' binds tighter than the or
            which results in problems...
            (by Monty)
  - running mysqlaccess with "perl -w" gives less warnings...   ;-)

  1.0-beta5: (1997-04-04)
  - bugfix: The table sorting was only being applied to the "user" table; all
            the tables need to be sorted.  Rewrote the sort algorithm, and
            the table walk algorithm (no temp file anymore), and various
            other cleanups.  I believe the access calculation is 100% correct.
            (by Paul D. Smith <psmith\@baynetworks.com>)
  - Allow the debug level to be set on the cmd line with --debug=N.
            (by Paul D. Smith <psmith\@baynetworks.com>)
  - More -w cleanups; should be totally -w-clean.
            (by Paul D. Smith <psmith\@baynetworks.com>)
 
  1.1-beta1: (1997-04-xx) 
  1.1-beta2: (1997-04-11)
  - new options:
             --all_users : report access-rights for all possible users
             --all_dbs   : report access-rights for all possible dbs
             --all_hosts : report access-rights for all possible hosts
             --brief     : as brief as possible, don't mention notes,warnings and rules
             --password  : validate password for user 
  - layout: long messages are wrapped on the report.
  - functionality:
            more descriptive notes and warnings
            wildcards (*,?) are allowed in the user,host and db options
            setting xxxx=* is equiv to using option --all_xxxx
            note: make sure you escape your wildcards, so they don't get
                  interpreted by the shell.  use \* or '*'
  - bugfix: Fieldnames which should be skipped on the output can now have
            a first capital letter.
  - bugfix: any option with a '.' (eg ip-number) was interpreted as
            a wildcard-expression.
  - bugfix: When no entry was found in the db-table, the default accessrights are
            N, instead of the faulty Y in a previous version.
 
  1.1-beta-3  : (1997-04-xx)
  1.1-beta-4  : (1997-04-xx)
  1.1-beta-5  : (1997-04-xx)
  1.1         : (1997-04-28)
  - new options:
            --rhost     : name of mysql-server to connect to
            --plan      : print suggestions/ideas for future releases
            --relnotes  : display release-notes
            --howto     : display examples on how to use mysqlaccess
            --brief     : single-line tabular output
  - functionality/bugfix:
    *      removed options --all_users,--all_dbs,--all_hosts, which 
           were redundant with the wildcard-expressions for the corresponding
           options. They made the processing of the commandline too painful 
           and confusing ;-)
           (suggested by psmith)
    *      redefined the option --brief, which now gives a single-line 
           tabular output
    *      Now we check if the right version of the mysql-client is used,
           since we might use an option not yet implemented in an
           older version (--unbuffered, since 3.0.18)
           Also the error-messages the mysql-client reports are 
           better interpreted ;-)  
    *      Wildcards can now be given following the SQL-expression 
           (%,_) and the Regular-expression (*,?) syntax.
  - speed: we now open a bidirectional pipe to the mysql-client, and keep 
           it open throughout the whole run. Queries are written to,
           and the answers read from the pipe.
           (suggested by monty)
  - bugfixes:
    *      the Rules were not properly reset over iterations 
    *      when in different tables the field-names were not identical, 
           eg. Select_priv and select_priv, they were considered as 
           definitions of 2 different access-rights.
    *      the IP-number of a host with a name containing wildcards should
           not be searched for in Name2IP and IP2Name.
    *      various other small things, pointed out by <monty> and <psmith>

  1.2         : (1997-05-13)
  - bugfix:
    * Fixed bug in acl with anonymous user:  Now if one gets accepted by the
      user table as a empty user name, the user name is set to '' when 
      checking against the 'db' and 'host' tables. (Bug fixed in Mysql3.20.x)

  1.2-1       : (1997-05-30)
  - bugfix:
    * hashes should  be initialized with () instead of {}.  This bug
      resulted in a warning when using perl 5.004 <psmith>
    * "my" variable $name masks earlier declaration in same scope,
      using perl 5.004 <????>

  1.2-2       : (1997-06-10)
  - bugfix:
    * value in fields in grant-tables are sorted case-insensitive. For this
      I had to change the WHERE into a HAVING :-(
    * Now if you try to log in with a password, only entries in 'user' with
      a password are examined.
      -> if mysqlaccess is called with the --password option, the entry in
         the user-table with a password is chosen;
         if called without the --password option, the entry with a non-blanc
         password field is prefered.
  
  1.2-3       : (1997-06-16)
  - bugfix: 
    * better messages...
    * the extra sort-column (ucase_host) has been removed from the output.

    
_RELEASE

$TODO = <<_TODO;

 Plans:
 -----
  -if the full WHERE comes available, replace HAVING by WHERE
  -add functionality to ADD user-privileges (!?)
  -add some more functionality for DNS.
  -select the warnings more carefuly.
  >>  I think that the warnings should either be enhanced to _really_
  >>  understand and report real problems accurately, or restricted to
  >>  only printing things that it knows with 100% certainty. <psmith)
  >>  Why do I have both '%' and 'any_other_host' in there?  Isn't that
  >>  the same thing?  I think it's because I have an actual host '%' in
  >>  one of my tables.  Probably the script should catch that and not
  >>  duplicate output. <psmith>
 - Why not use the mysqlperl module this would make the following
   things much easier: (monty)
   >>I'd like to see this optional; not everyone will want to install the perl
   >>stuff, but everyone will want to use this script! <psmith>
   >>>>For the moment I'll stick with the 'mysql' program.  <ycarlier>

_TODO

# From the FAQ: the Grant-algorithm
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# The host table is mainly to maintain a list of "secure" servers.
# At TCX hosts contain a list of all machines on local network. These are granted
# all privileges.
# Technically the user grant is calculated by:
#
#    1.First sort all entries by host by putting host without wildcards first,
#      after this host with wildcards and entries with host = ".
#      Under each host sort user by the same criterias.
#    2.Get grant for user from the "db" table.
#    3.If hostname is "empty" for the found entry, AND the privileges with
#      the privileges for the host in "host" table.
#      (Remove all which is not "Y" in both)
#    4.OR (add) the privileges for the user from the "user" table.
#     (add all privileges which is "Y" in "user")
#
#    When matching, use the first found match.
#
# -----------------------------------------------------------------------------------

$HOWTO = <<_HOWTO;

Examples of how to call $script:
~~~~~~~~
1)Calling $script with 2 arguments:

  \$ mysqlaccess root mysql
     ->report rights of user root logged on at the local host in db mysql

  Access-rights
  for USER 'root', from HOST 'localhost', to DB 'mysql'
          +-----------------+---+ +-----------------+---+
          | select_priv     | Y | | drop_priv       | Y |
          | insert_priv     | Y | | reload_priv     | Y |
          | update_priv     | Y | | shutdown_priv   | Y |
          | delete_priv     | Y | | process_priv    | Y |
          | create_priv     | Y | | file_priv       | Y |
          +-----------------+---+ +-----------------+---+
  BEWARE:  Everybody can access your DB as user 'root'
        :  WITHOUT supplying a password.  Be very careful about it!!

  The following rules are used:
   db    : 'No matching rule'
   host  : 'Not processed: host-field is not empty in db-table.'
   user  : 'localhost','root','','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y'

2)Calling $script with 3 arguments:

  \$ mysqlaccess foo.bar nobody Foo 
     ->report rights of user root logged in at machine foobar to db Foo

  Access-rights
  for USER 'nobody', from HOST 'foo.bar', to DB 'Foo'
          +-----------------+---+ +-----------------+---+
          | select_priv     | Y | | drop_priv       | N |
          | insert_priv     | Y | | reload_priv     | N |
          | update_priv     | Y | | shutdown_priv   | N |
          | delete_priv     | Y | | process_priv    | N |
          | create_priv     | N | | file_priv       | N |
          +-----------------+---+ +-----------------+---+
  BEWARE:  Everybody can access your DB as user 'nobody'
        :  WITHOUT supplying a password.  Be very careful about it!!

  The following rules are used:
   db    : 'foo.bar','Foo','nobody','Y','Y','Y','N','N','N'
   host  : 'Not processed: host-field is not empty in db-table.'
   user  : 'foo.bar','nobody','','N','N','N','Y','N','N','N','N','N','N'

3)Using wildcards:

  \$ mysqlaccess  \\* nobody Foo --brief
     ->report access-rights of user nobody from all machines to db Foo,
       and use a matrix-report.

  Sel  Ins  Upd  Del  Crea Drop Reld Shut Proc File Host,User,DB        
  ---- ---- ---- ---- ---- ---- ---- ---- ---- ---- --------------------
   Y    Y    Y    Y    N    N    N    N    N    N   localhost,nobody,Foo
   N    N    N    N    N    N    N    N    N    N   %,nobody,Foo  
   N    N    N    N    N    N    N    N    N    N   any_other_host,nobody,Foo

_HOWTO

#
# +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# 

use Getopt::Long;
use Socket;
use Sys::Hostname;
use IPC::Open2;

# ****************************
# debugging flag
# can be set to 0,1,2,3
# a higher value gives more info
# ! this can also be set on the command-line
	$DEBUG   = 0;

# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++>8
#  Normaly nothing should be changed beneeth this line


# ****************************
# no caching on STDOUT
	$|=1;

# ****************************
# information on MySQL
	$MYSQL     = '@bindir@/mysql --batch --unbuffered';
	$ACCESS_DB = 'mysql';		 # name of DB with grant-tables
#	$ACCESS_DB = 'mysql_test';		 # name of DB with grant-tables
	$ACCESS_H  = 'host';		 # 
	$ACCESS_U  = 'user';	       # 
	$ACCESS_D  = 'db';             #
        %ACCESS_ERR= ('Access_denied' => 'Access denied' 
                     ,'Dbaccess_denied' => 'Access to database denied'
                     ,'Unrecognized_option' => 'unrecognized option' 
                     ,'unknown_error'       => '^ERROR:'
                     );

 
# ***********************************
# translation-table for poss. answers
%Answer =  ('Y' =>  1 , 'N' =>  0
           , 1  => 'Y',  0  => 'N'
           ,'?' => '?'
           );

# ****************************
# Notes and warnings
%Messages = ( 
  'insecure_user' 
   => "Everybody can access your DB as user `\$user' from host '\$host'\n"
     ."WITHOUT supplying a password.\n"
     ."Be very careful about it!!"
 ,'password_required' 
   => "A password is required for user `\$user' :-("
 ,'invalid_password'
   => "The password '\$password' for user `\$user' is invalid :-P"
 , 'valid_password'
   => "You supplied the right password for user `\$user' :-)"
 ,'public_database' 
   => "Any user with the appropriate permissions has access to your DB!\n"
     ."Check your users!"
 ,'full_access' 
   => "All grant-tables are empty, which gives full access to ALL users !!"
 ,'no_rule_found'
   => "No matching rule"
 ,'no_equiv_host' 
   => "Not processed: host-field is not empty in db-table."
 ,'least_priv'
   => "If the final priveliges of the user are more then you gave the user,\n"
     ."check the priveliges in the db-table `\$db'."
 ,'minimum_priv'
   => "The privileges for any new user are AT LEAST\n"
     ."the ones shown in the table above,\n"
     ."since these are the privileges of the db `\$db'.\n"
 ,'Unrecognized_option'
   => "Sorry,\n"
     ."You are using an old version of the mysql-program,\n"
     ."which does not yet implement a neccessary option.\n"
     ."\n"
     ."You need at least Version 6.2 of the mysql-client,\n"
     ."which was build in MySQL v3.0.18, to use this version\n"
     ."of `$script'."
 ,'Access_denied'
   => "Sorry,\n"
     ."An error occured when trying to connect to the database\n"
     ."with the grant-tables:\n"
     ."* Maybe YOU do not have READ-access to this database?\n"
     ."* If you used the -U option, you may have supplied an invalid username?\n"
     ."  for the superuser?\n"
     ."* If you used the -U option, it may be possible you have to supply\n"
     ."  a superuser-password to, with the -P option?\n"
     ."* If you used the -P option, you may have supplied an invalid password?\n"
 ,'Dbaccess_denied'
   => "Sorry,\n"
     ."An error occured when trying to connect to the database\n"
     ."with the grant-tables. (dbaccess denied)\n"
 ,'unknown_error'
   => "Sorry,\n"
     ."An error occured when trying to connect to the database\n"
     ."with the grant-tables. (unknown error)\n"
 ,'anonymous_access'
   => "Accessing the db as an anonymous user.\n"
     ."Your username has no relevance\n"
 );
@Errors   = ();
@Warnings = ();
@Notes    = ();
$NEW_USER = 'ANY_NEW_USER';
$NEW_DB   = 'ANY_NEW_DB'  ;


# ****************************
# information on used rules
$full_access = 1; #if the grant-tables are empty, full access is granted to everyone
%Rules = ( 'db'   => 'no_rule_found'
         , 'host' => 'no_rule_found'
         , 'user' => 'no_rule_found'
         );


# %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% #
#  mysqlaccess:                                              #
#  ~~~~~~~~~~~                                               #
#  Lets get to it,                                           #
#  and start the program by processing the parameters        #
# %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% #

# ****************************
# the copyright message should
# always be printed (once)
print Header();

# ----------------------------
# Get options from commandline
$Getopt::Long::ignorecase=0; #case sensitive options
if ( grep(/\-\?/,@ARGV) ) { help(); exit 0; }
GetOptions("help"          => \$help
          ,"host|h=s"      => \$host
          ,"user|u=s"      => \$user
          ,"password|p=s"  => \$password
          ,"db|d=s"        => \$db
          ,"superuser|U=s" => \$superuser
          ,"spassword|P=s" => \$spassword
          ,"rhost|H=s"     => \$rhost
          ,"debug=i"       => \$DEBUG
          ,"brief"         => \$brief
          ,"relnotes"      => \$relnotes
          ,"plan"          => \$plan
          ,"howto"         => \$howto
          ,"version|v"     => \$version
	  );


# -----------------------------
# check for things which aren't
# declared as options:
# 2 arguments: (user,db) -> ('localhost','user','db')
if ($#ARGV == 1) {
   print "$script called with 2 arguments:\n" if ($DEBUG>2);
   if (!defined($host)) { $host='localhost'; }
   if (!defined($user)) { $user=$ARGV[0]; }
   if (!defined($db))   { $db  =$ARGV[1]; }
}
# 3 arguments: (host,user,db)
if ($#ARGV == 2) {
   print "$script called with 3 arguments:\n" if ($DEBUG>2);
   if (!defined($host)) { $host=$ARGV[0]; }
   if (!defined($user)) { $user=$ARGV[1]; }
   if (!defined($db))   { $db  =$ARGV[2]; }
}

# ----------------------
# if no host is given
# assume we mean 'localhost'
if (!defined($host)) { $host='localhost'; }

#-----------------------
# get info/help if necc.
# and exit.
if ( defined($version) ) {
   Print_Version();
   exit 0;
}
if ( defined($relnotes) ) {
   Print_Relnotes();
   exit 0;
}
if ( defined($plan) ) {
   Print_Plans();
   exit 0;
}
if ( defined($howto) ) {
   Print_HowTo();
   exit 0;
}

if ( defined($help) 
     or !defined($user) 
     or !defined($host)
     or !defined($db) 
   ) {
   help();
   exit 0;
}


# ----------------------------
# get hostname and local-ip
# for localhost
$localhost = LocalHost();
$local_ip  = Name2IP($localhost);
	print "  --localhost=$localhost\n" if ($DEBUG>2);
	print "  --local_ip =$local_ip\n" if ($DEBUG>2);


#---------------------------------
# Inform user if he has not enough
# privileges to read the access-db
if ( $nerror=OpenConnection() ) {
    Print_Error_Access($nerror);
    exit 0;
}
else {
    @sorted_db_table  =Sort_table($ACCESS_D, 'ucase_host', 'user', 'db');
    @sorted_host_table=Sort_table($ACCESS_H, 'ucase_host', 'db');
    @sorted_user_table= defined($password) ?
                        Sort_table($ACCESS_U, 'ucase_host', 'user','password'):
                        Sort_table($ACCESS_U, 'ucase_host', 'user');
}


# -----------------------------
# Get record-layout 
($h1,$h2)= Show_Fields($ACCESS_H);
%H = %{$h1}; @H = @{$h2};
($d1,$d2)= Show_Fields($ACCESS_D);
%D = %{$d1}; @D = @{$d2};
($u1,$u2) = Show_Fields($ACCESS_U);
%U = %{$u1}; @U = @{$u2};
@privlist=@{Make_Privlist()};

# -----------------------------
# Build list of users,dbs,hosts
# to process...
@all_dbs   = @{Get_All_dbs($db)};
@all_users = @{Get_All_users($user)};
@all_hosts = @{Get_All_hosts($host)};
if ((@all_dbs>1 or @all_users>1 or @all_hosts>1) 
     and !$brief ) { 
  $separator=" --------------------------------------------------------------\n";
}
else { $separator=""; }

# -----------------------------
# Report access-rights for each
# tuple (host,user,db)
$headers=0;
foreach $host (@all_hosts) {
  foreach $user (@all_users) {
    foreach $db (@all_dbs) {
      @Errors=();
      @Warnings=();
      @Notes=();
      Report_Access_Rights($host,$user,$db);
      print "$separator";
    }
  }
}

# -----------------------------
# End script
#print Footer();
CloseConnection();
exit 0;

#############################################################
#  FUNCTIONS  #
###############




# ===========================================================
# sub Report_Access_Rights()
#  report the access_rights for the tuple ($host,$user,$db).
# ===========================================================
sub Report_Access_Rights {
  local ($host,$user,$db) = @_;
  # ******************************************************************************
  # Create default access-rights
  #   default access-rights are no access at all!!
  local %Access       = %{Default_Access_Rights()};

  # ******************************************************************************
  # get hostname for IP-address
  # get IP-address for hostname
  local $host_name = IP2Name($host);
  local $host_ip   = Name2IP($host);

	print "DEBUG $script:\n" if ($DEBUG>0);
	print "  --host=$host\n" if ($DEBUG>0);
	print "    hostname=$host_name\n" if ($DEBUG>0);
	print "    host-ip =$host_ip\n" if ($DEBUG>0);
	print "  --user=$user\n" if ($DEBUG>0);
	print "  --db  =$db\n"  if ($DEBUG>0);

  # ***********************************************************************
  # retrieve information on USER
  #  check all records in mysql::user for matches with the tuple (host,user)
  # ***********************************************************************
  #    4.OR (add) the privileges for the user from the "user" table.
  #     (add all privileges which is "Y" in "user")

  ($_host_,$_user_,$_encpw_) = Get_grant_from_user($host,$user);
  if ($_user_ eq $NEW_USER) { 
     push(@Warnings,'minimum_priv');
  }
  if ($_user_ ne $user) {
     $user=$_user_;
     push(@Warnings,'anonymous_access');
  }


  # *******************************************************
  #  Validate password if this has been asked to do
  # *******************************************************
  if (defined($password)) {
     $valid = Validate_Password($password,$_host_,$_user_,$_encpw_);
     if (!$valid) { push(@Errors,'invalid_password'); }
     else         { push(@Notes,'valid_password'); }
  }

  # ******************************************************************************
  # retrieve information on DB
  #  check all records in mysql::db for matches with the triple (host,db,user)
  #  first match is used.
  # ******************************************************************************
  #    2.Get grant for user from the "db" table.

  $process_host_table=Get_grant_from_db($host,$db,$user); #set process_host_table

  # ***********************************************************************
  # retrieve information on HOST
  #  check all records in mysql::host for matches with the tuple (host,db)
  #
  #  ' The host table is mainly to maintain a list of "secure" servers. '
  # ***********************************************************************
  #    3.If hostname is "empty" for the found entry, AND the privileges with
  #      the privileges for the host in "host" table.
  #      (Remove all which is not "Y" in both)

  Get_grant_from_host($host,$db);

  # *******************************************************
  #  Report the access-rights on STDOUT
  # *******************************************************
  Print_Access_rights(\%Access);
}






# ######################################
#  REPORTING 
# =====================================
# sub Header:
#  print header info
# =====================================
sub Header {
    my $header;
    $header="$script Version $VERSION\n"
           ."By RUG-AIV, by Yves Carlier (Yves.Carlier\@rug.ac.be)\n"
           ."This software comes with ABSOLUTELY NO WARRANTY.\n";
    return $header;
}

# =====================================
# sub Footer:
#  print footer info
# =====================================
sub Footer {
    my $footer;
    $footer="\n"
           ."BUGs can be reported by email to Yves.Carlier\@rug.ac.be\n"
           ."Don't forget to mention the version $VERSION!\n";
    return $footer;
}


# =====================================
# sub help:
#  print some information on STDOUT
# =====================================
sub help {
    Print_Options();
    return 1;
}

# ======================================
# sub Print_Version:
# ======================================
sub Print_Version {
    print $INFO;
    print Footer();
    return 1;
}

# ======================================
# sub Print_Relnotes:
# ======================================
sub Print_Relnotes {
    print $RELEASE;
    return 1;
}

# ======================================
# sub Print_Plans:
# ======================================
sub Print_Plans {
    print $TODO;
    return 1;
}

# ======================================
# sub Print_HowTo:
# ======================================
sub Print_HowTo {
    print $HOWTO;
    return 1;
}

# ======================================
# sub Print_Options:
# ======================================
sub Print_Options {
    print $OPTIONS;
    return 1;
}

# ======================================
# sub Print_Error_Access:
# ======================================
sub Print_Error_Access {
    my ($error) = @_;
    print "\n";
    print $Messages{$error};
    print "\n";
    return 1;
}


# ======================================
# sub Print_Access_rights:
#  print the access-rights on STDOUT
# ======================================
sub Print_Access_rights {
    my ($refhash) = @_;

    if (defined($brief)) { Matrix_Report($refhash);  }
    else                 { Tabular_Report($refhash); }
    return 1;
}

# ======================================
# sub Tabular_Report
#  Tabular report,
#  suitable for 1 triple (host,db,user)
# ======================================
sub Tabular_Report {
    my ($a) = @_;
    my $column=2;
    
    # -----------------------------
    # print table of access-rights
    my $rows = int(@privlist/2);  #round up
    my @table=();
    $j=0;
    for $i (0 .. $rows-1) {
      $table[$j]=$privlist[$i];
      $j = $j+2;
    }
    $j=1;
    for $i ($rows .. $#privlist) {
      $table[$j]=$privlist[$i];
      $j = $j+2;
    }
    print "\n";
    print "Access-rights\n";
    print "for USER '$user', from HOST '$host', to DB '$db'\n";
    print      "\t+-----------------+---+\t+-----------------+---+";
    foreach $field (@table) {
	if ($column==2) { print "\n\t"; $column=1;}
	else            { print "\t";   $column=2;}
	printf "| %-15s | %s |",$field,$Answer{$a->{$field}}; 
    }
    print      "\n";
    print      "\t+-----------------+---+\t+-----------------+---+\n";

    # ---------------
    # print notes:
    foreach $note (@Notes) {
      my $message = $Messages{$note};
      $message =~ s/\$user/$user/g; 
      $message =~ s/\$db/$db/g;
      $message =~ s/\$host/$host/g;
      $message =~ s/\$password/$password/g;
      $PREFIX='NOTE';
      my @lines = split(/\n/,$message);
      foreach $line (@lines) { 
        print "$PREFIX:\t $line\n"; 
        $PREFIX='    ';
      }
    } 

    # ---------------
    # print warnings:
    foreach $warning (@Warnings) {
      my $message = $Messages{$warning};
      $message =~ s/\$user/$user/g;
      $message =~ s/\$db/$db/g;
      $message =~ s/\$host/$host/g;
      $message =~ s/\$password/$password/g;
      $PREFIX='BEWARE';
      my @lines = split(/\n/,$message);
      foreach $line (@lines) { 
        print "$PREFIX:\t $line\n"; 
        $PREFIX='      ';
      }
    }

    # ---------------
    # print errors:
    foreach $error (@Errors) {
      my $message = $Messages{$error};
      $message =~ s/\$user/$user/g;
      $message =~ s/\$db/$db/g;
      $message =~ s/\$host/$host/g;
      $message =~ s/\$password/$password/g;
      $PREFIX='ERROR';
      my @lines = split(/\n/,$message);
      foreach $line (@lines) { 
        print "$PREFIX:\t $line\n"; 
        $PREFIX='    ';
      }
    }

    # ---------------
    # inform if there are no rules ==> full access for everyone.
    if ($full_access) { print "$Messages{'full_access'}\n"; }

    # ---------------
    # print the rules used
    print "\n";
    print "The following rules are used:\n";
    foreach $field (sort(keys(%Rules))) {
      my $rule = (defined($Messages{$Rules{$field}}) ? $Messages{$Rules{$field}} : $Rules{$field});
      $rule =~ s/\t/','/g;
      printf " %-5s : '%s'\n",$field,$rule;
    }
    return 1;
}

# ======================================
# sub Matrix_Report:
#  single-line output foreach triple,
#  no notes,warnings,...
# ======================================
sub Matrix_Report {
    my ($a) = @_;
    my @headers = ();
    
    if (! $headers) {
       # -----------------------------
       # create column-headers
       foreach $field (@privlist) {
         push(@headers,substr($field,0,4));
       }
       #@headers = ('Sel','Ins','Upd','Del','Crea','Drop','Reld'
       #           ,'Shut','Proc','File');
    
       # -----------------------------
       # print column-headers
       print "\n";
       my $line1="";
       my $line2="";
       foreach $header (@headers) {
         $line1 .= sprintf("%-4s ",$header);
         $line2 .= sprintf("%s ",'----');
       }
       $line1 .= sprintf("| %-20s",'Host,User,DB');
       $line2 .= sprintf("+ %-20s",'-' x 20);
       print "$line1\n";
       print "$line2\n";
       $headers=1;
     }

    # print access-information
    foreach $field (@privlist) {
	printf " %-2s  ",$Answer{$a->{$field}}; 
    }
    printf "| %-20s",join(',',$host,$user,$db);
    print "\n";

    return 1;
}




#package DB;
# ######################################
#  Connecting to the MYSQL DB
# ======================================
# sub OpenConnection
#  Open an connection to the mysql-db
#  questions to MYSQL_Q
#  answers from MYSQL_A
# ======================================
sub OpenConnection {
    my $pid;
    print "OpenConnection:\n" if ($DEBUG>2);

    # path to mysql executable
    my $connect = $main::MYSQL;
    # user,password and host
    if (defined($main::superuser)) { $connect .= " --user=$main::superuser"; }
    if (defined($main::spassword)) { $connect .= " --password=$main::spassword"; }
    if (defined($main::rhost))     { $connect .= " --host=$main::rhost"; }
    # other options??

    # grant-database
    $connect .= " $main::ACCESS_DB";

    $connect .= " 2>&1";
    # open connection
    print "Connecting to: $connect\n" if ($DEBUG>2);         
    $pid=IPC::Open2::open2(\*MYSQL_A,\*MYSQL_Q,$connect);
    print "PID of open pipe: $pid\n" if ($DEBUG>2);
    
    # check connection 
    print MYSQL_Q "select 'ok';\n";
    $answer = <MYSQL_A>; #answer from mysql
    print "Answer: $answer\n" if ($DEBUG>2);
    foreach $nerror (sort(keys(%ACCESS_ERR))) {
      print "> $ACCESS_ERR{$nerror}" if ($DEBUG>2);
      if (grep(/$ACCESS_ERR{$nerror}/i,$answer)) { 
         print " [$nerror] <<--\n" if ($DEBUG>2);
         return $nerror; 
      }
      print "\n" if ($DEBUG>2);
    }
    if ( grep(/$answer/i,@error)) { return 1; }
    else                          { my $skip=<MYSQL_A>; return 0; }
}

# ======================================
# sub CloseConnection
#  Close the connection to the mysql-db
# ======================================
sub CloseConnection {
    close MYSQL_Q;
    close MYSQL_A;
}

# ======================================
# sub LaunchQuery
#  Launch an SQL-query
# ======================================
sub LaunchQeury {
    print STDOUT "Query: $query\n" if ($main::DEBUG>2);
    print MYSQL_Q "$query";
    my $skip = <MYSQL_A>;  #skip header
    return 1;
}


# ======================================
# sub GetAnswer
#  Read the next record from the answer
# ======================================
sub GetAnswer {
    my $record = <MYSQL_A>;     #read record
    chop($record);
#    Debug::Print(2," A>: $record");
    if ($record eq "ok") { return undef; }
    else                 { return $record; }
}


# ===========================================================
# sub Show_Fields($table): 
#  return (a reference to) a hash which holds the names
#  of all relevant grant-fields, with their index in the record,
#  and (a reference to) an array which holds the fieldnames.
# ===========================================================
sub Show_Fields {
    my ($table) = @_;
    my %skip = ('host' => [0,1]
               ,'user' => [0,1,2]
               ,'db'   => [0,1,2]
               );
    my %Struct = ();
    my @Struct = ();
    my $query = "show fields from $table;select 'ok';\n";
    my $i=0;
    my $line;

    print STDOUT "Show_Fields($table):\n" if ($main::DEBUG>1);
    print STDOUT "SQL: $query\n" if ($main::DEBUG>2);

    print MYSQL_Q "$query";
    my $skip = <MYSQL_A>;  #skip header
    while (($line=<MYSQL_A>) ne "ok\n")
    {
	chop($line);
	print " $table>: $line\n" if ($main::DEBUG>2);
	my ($field,$type,$null,$key,$default,$extra) = split(' ',$line);
        $field = ucfirst($field); 
	print " <split: $field - $type - $null - $key - $default - $extra\n" if ($DEBUG>2);
	if (! grep(/$i/,@{$skip{$table}}) ){
	   $Struct{$field} = $i; #hash
	   push(@Struct,$field); #array
	   print " ==> added column[$i]: $field ($Struct{$field})\n" if ($main::DEBUG>2);
	} 
        else {
           print " ==> skipped column[$i], value=[$field]\n" if ($main::DEBUG>2);
        }
	$i++;
    }

    $skip=<MYSQL_A>;  # Get ok row (found already ok header)

    if ($main::DEBUG>2) {
       print "Array:\n";
       foreach $field (@Struct) { print "+ $field\n"; }
       print "Hash:\n";
       foreach $field (keys(%Struct)) { print "+ $field -> $Struct{$field}\n"; }
    }
    return  (\%Struct,\@Struct); 
}

# ======================================
# sub Validate_Password($passwd,$host,$user,$encpw)
#  Validate the given password 
#  for user '$user' 
#  connecting from host '$host'
# ======================================
sub Validate_Password {
    my ($password,$host,$user,$encpw) = @_;
    my $valid=0;
    print STDOUT "Validate_Password($password,$host,$user,$encpw)\n" if ($DEBUG>1);
    my $sql = "select host,user,password from user having "
             ."host='$host' and user='$user' and password='$encpw' "
             ."and password=PASSWORD('$password');\n";
    $sql .= "select 'ok';\n";
    print STDOUT "SQL = $sql\n" if ($main::DEBUG>2);
    print MYSQL_Q "$sql";
    
    # if password is valid, at least 1 row returns before we read 'ok'
    while ( ($line=<MYSQL_A>) ne "ok\n") {
      print " A> $line" if ($main::DEBUG>2);
      $valid = defined($line); 
    }
    my $skip = <MYSQL_A>; # read 'ok'

    return $valid;
}


# ==========================================================
# sub Sort_fields: (rewritten by psmith)
#  Build the query for an ordered list of entries
# ==========================================================
sub Sort_fields {
  my ($start, $end, $sofar, $this, @rest) = (@_);
  my @where = ("((FIELD not like '\\%') AND (FIELD <> ''))",
               "((FIELD like '%\\%%') OR (FIELD like '%\\_%'))",
               "(FIELD = '')");
  my $res = '';

  $this or return ("$start $sofar $end");

  $sofar .= ' AND ' if $sofar;

  foreach $w (@where) {
    my $f = $w;
    $f =~ s/FIELD/$this/g;

    $res .= Sort_fields($start, $end, "$sofar$f", @rest);
  }

  return ($res);
}

# ===========================================================
# sub Sort_table: (rewritten by psmith)
#  return all entries in the given table,
#  in an ordered fashion
# ===========================================================
sub Sort_table {
    my ($tbl, @order) = @_;
    my @res=();

# as long as there's no full where clause...
#    my $start = "SELECT * FROM $tbl WHERE";
#    my $end = 'ORDER BY ' . join(',', @order) . ";\n";

    my $start = "SELECT *,UCASE(host) as ucase_host FROM $tbl ";
    $start   .= 'ORDER BY ' . join(',', @order) ." HAVING ";
    my $end   = ";\n";

    print STDOUT "Sort_table()\n" if ($main::DEBUG>1);
    print STDOUT "Sorting table $tbl by `@order'\n" if ($main::DEBUG>2);

    my $query  = Sort_fields($start, $end, '', @order);
    $query    .= "select 'ok';\n";
    print STDOUT "Query: $query\n" if ($main::DEBUG>2);

    print MYSQL_Q "$query\n";
#    LaunchQuery($query);

    my $delim = <MYSQL_A>; # read header
    print STDOUT " A> $delim" if ($main::DEBUG>2);
    while (($line=<MYSQL_A>) ne "ok\n")
    {
        print STDOUT " A> $line" if ($main::DEBUG>2);
	push(@res,$line);
    }
    my $skip = <MYSQL_A>; # skip result 'ok'

    #close(MYSQL);
    @res = grep(!/^\Q$delim\E$/, @res);
    chomp(@res); 
    @res = grep { /(.*)\t.*$/; $_ = $1; } @res;

    if ($main::DEBUG>2) {
       print "Result of sorted table $tbl:\n";
       foreach $line (@res) { print STDOUT " >>$line\n"; }
    }
    return @res;
exit 0;
}

# ===========================================================
# sub Get_All_db(template): 
#  return all db the grant-tables are working on,
#  which conform to the template
# ===========================================================
sub Get_All_dbs {
   my ($template) = @_;
   my @db=();
   print "Debug Get_All_dbs:\n" if ($main::DEBUG>1);

   # get all db for which access-rights can be calculated,
   # which conform to the template.
   # !! these db's don't have to exist yet, so it's not
   #    enough to look which db already exist on the system
   $reg_expr = $template;
   if ($template =~ /[\*\?]/) {
      $reg_expr =~ tr/*?/%_/;
      #$reg_expr = Wild2Reg($template);
   }
   $reg_expr = SQL2Reg("$reg_expr");

   if ( ! ($template =~ /[\*\?%_]/) ) {
      push(@db,$template);
      return \@db;
   }

   print "#Reading db-table...\n" if ($main::DEBUG>2);
   foreach $record (@main::sorted_db_table) {
    my @record=split(/\t/,$record);
    my $db = $record[1];
    print "> $db " if ($DEBUG>2);
    if ( (!grep(/$db/,@db)) and ($db =~/$reg_expr/) ) {
       push(@db,$db);
       print "added\n" if ($DEBUG>2);
    } 
    else {
       print "skipped\n" if ($DEBUG>2);
    }
   }
   # if no rule is found for a certain db in the db-table,
   # the rights of the user are used, so we should inform
   # the user for
   if (!grep(/^%$/,@db)) { push(@db,"$NEW_DB"); }
   return \@db;
}

# ===========================================================
# sub Get_All_users(template): 
#  return all users the grant-tables are working on,
#  which conform to the template
# ===========================================================
sub Get_All_users {
   ($template) = @_; # nog verder uitwerken!!!
   my @user=();

   print "Debug Get_All_users:\n" if ($DEBUG>1);
   # get all db for which access-rights can be calculated.
   # !! these db's don't have to exist yet, so it's not
   #    enough to look which db already exist on the system
   $reg_expr = $template;
   if ($template =~ /[\*\?]/) {
      $reg_expr =~ tr/*?/%_/;
      #$reg_expr = Wild2Reg($template);
   }
   $reg_expr = SQL2Reg("$reg_expr");

   if ( ! ($template =~ /[\*\?%_]/) ) {
      push(@user,$template);
      return \@user;
   }

   print "#Reading user-table...\n" if ($DEBUG>1);
   foreach $record (@main::sorted_user_table) {
    my @record=split(/\t/,$record);
    my $user = $record[1];
    print "> $user " if ($DEBUG>2);
    if ( (!grep(/$user/,@user)) and ($user=~/$reg_expr/)) {
       push(@user,$user);
       print "added\n" if ($DEBUG>2);
    } 
    else {
       print "skipped\n" if ($DEBUG>2);
    }
   }
   # Any user means also:
   # - the 'empty' user, ie without supplying a username
   # - any user still to be defined/created
   #push(@user,'');               #without_suplying_a_username
   push(@user,"$NEW_USER");
   #push(@Warnings,'minimum_priv');
   return \@user;
}

# ===========================================================
# sub Get_All_hosts(template): 
#  return all hosts the grant-tables are working on,
#  which conform to the template
# ===========================================================
sub Get_All_hosts {
   my ($template) = @_;
   my @host=();

   print "Debug Get_All_hosts:\n" if ($DEBUG>1);
   # get all db for which access-rights can be calculated.
   # !! these db's don't have to exist yet, so it's not
   #    enough to look which db already exist on the system
   $reg_expr = $template;
   if ($template =~ /[\*\?]/) {
      $reg_expr =~ tr/*?/%_/;
      #$reg_expr = Wild2Reg($template);
   }
   $reg_expr = SQL2Reg("$reg_expr");

   if ( ! ($template =~ /[\*\?%_]/) ) {
      push(@host,$template);
      return \@host;
   }

   print "#Reading db-table...\n" if ($DEBUG>1);
   foreach $record (@main::sorted_db_table) {
    my @record=split(/\t/,$record);
    my $host = $record[0];
    print "> $host " if ($DEBUG>2);
    if (! grep(/$host/,@host)) {
       push(@host,$host);
       print "added\n" if ($DEBUG>2);
    } 
    else {
       print "skipped\n" if ($DEBUG>2);
    }
   }
   print "#Reading host-table...\n" if ($DEBUG>1);
   foreach $record (@main::sorted_host_table) {
    my @record=split(/\t/,$record);
    my $host = $record[0];
    print "> $host " if ($DEBUG>2);
    if ( (!grep(/$host/,@host)) and ($host=~/$reg_expr/)) {
       push(@host,$host);
       print "added\n" if ($DEBUG>2);
    } 
    else {
       print "skipped\n" if ($DEBUG>2);
    }
   }
   # DOUBT:
   #print "#Reading user-table...\n" if ($DEBUG>1);
   #foreach $record (@main::sorted_user_table) {
   # my @record=split(/\t/,$record);
   # my $host = $record[0];
   # print "> $host " if ($DEBUG>2);
   # if ( (!grep(/$host/,@host)) and ($host=~/$reg_expr/)) {
   #    push(@host,$host);
   #    print "added\n" if ($DEBUG>2);
   # } 
   # else {
   #    print "skipped\n" if ($DEBUG>2);
   # }
   #}
   # Any host also means:
   # - any host still to be defined/created
   #push(@host,"any_other_host");
   @host = sort(@host);
   return \@host;
}

#package Wildcards;
# ############################################
# SQL, WILDCARDS and REGULAR EXPRESSIONS 
# ============================================
# translage SQL-expressions to Reg-expressions
# ============================================
sub SQL2Reg {
    my ($expr) = @_;
    print "SQL2Reg: $expr " if ($DEBUG>2);
    $expr  =~ s/\./\\./g;
    $expr  =~ s/\\%/\002/g;
    $expr  =~ s/%/.*/g;
    $expr  =~ s/\002/%/g;
    $expr  =~ s/\\_/\002/g;
    $expr  =~ s/_/.+/g;
    $expr  =~ s/\002/_/g;
    print " --> $expr\n" if ($DEBUG>2);
    return $expr;
}

# translage WILDcards to Reg-expressions
# ============================================
sub Wild2Reg {
    my ($expr) = @_;
    print "Wild2Reg: $expr " if ($DEBUG>2);
    $expr  =~ s/\./\\./g;
    $expr  =~ s/\\\*/\002/g;
    $expr  =~ s/\*/.*/g;
    $expr  =~ s/\002/*/g;
    $expr  =~ s/\\\?/\002/g;
    $expr  =~ s/\?/.+/g;
    $expr  =~ s/\002/?/g;
    print " --> $expr\n" if ($DEBUG>2);
    return $expr;
}

# =============================================
# match a given string with a template
# =============================================
sub MatchTemplate {
    my ($tpl,$string) = @_;
    my $match=0;
    print "MatchTemplate: $tpl <-> $string : " if ($DEBUG>2);
    if ($string=~ /^$tpl$/ or $tpl eq '') { $match=1; }
    else                                  { $match=0;}
    print "result=$match\n" if ($DEBUG>2);
    return $match;
}

#package Host;
# ######################################
# HOSTNAMES, IP-NUMBERS and ALIKE
# ======================================
# sub IP2Name
#  return the Name with the corr. IP-nmbr
#  (no aliases yet!!)
# ======================================
sub IP2Name {
    my ($ip) = @_;
    print STDOUT "IP2Name():\n" if ($main::DEBUG>1);
    if ($ip !~ /([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)/o) {
      print STDOUT "not an ip-number, returning undef\n" if ($main::DEBUG>2);
      return $ip;
    }
    print STDOUT "* ip=$1.$2.$3.$4\n" if ($main::DEBUG>2);
    $ip = pack "C4",$1,$2,$3,$4;
    print STDOUT "* ==>>$ip<<\n" if ($main::DEBUG>2);
    my ($name,$aliases,$addrtype,$length,@addrs) = gethostbyaddr($ip, AF_INET);

    print STDOUT "* name=$name\n* aliases=$aliases\n* addrtype=$addrtype\n* length=$length\n"       if ($main::DEBUG>2);

    return ($name || undef);
}

# ======================================
# sub Name2IP
#  return the IP-number of the host
# ======================================
sub Name2IP {
    my ($_name) = @_;
    print STDOUT "Name2IP():\n" if ($main::DEBUG>1);
    print STDOUT "* name=$_name\n" if ($main::DEBUG>2);
    if ($_name =~ /[%_]/) { return $_name; }
    my ($name,$aliases,$addrtype,$length,@addrs) = gethostbyname($_name);
    print STDOUT "* aliases=$aliases\n" if ($main::DEBUG>2);
    print STDOUT "* addrtype=$addrtype\n" if ($main::DEBUG>2);
    print STDOUT "* length=$length\n" if ($main::DEBUG>2);
    my ($a,$b,$c,$d) = unpack('C4',$addrs[0]);
    my $ip = "$a.$b.$c.$d";
    print STDOUT "* ip=$ip\n" if ($main::DEBUG>2);
    if ($ip ne "") { return "$ip"; }
    else           { return undef; }
}

# ========================================
# sub LocalHost
#  some special action has to be taken for
#  the localhost
# ========================================
sub LocalHost {
    my $host = Sys::Hostname::hostname();
    print STDOUT "localhost = $host\n" if ($main::DEBUG>2);
    return $host;
}

# ========================================
# check if the given hostname (or ip)
# corresponds with the localhost
# ========================================
sub Is_localhost {
    my ($host_tpl) = @_;
    if (($host_name eq $localhost) or ($host_ip eq $local_ip)) {
	print STDOUT "Checking for localhost\n" if ($main::DEBUG>2);
        print STDOUT " 'localhost' =?= $host_tpl\n" if ($main::DEBUG>2);
	if ('localhost' =~ /$host_tpl/ ) { return 1;}
	else			         { return 0;}
    }
    else {
	print STDOUT "Not checking for localhost\n" if ($main::DEBUG>2);
	return 0;
    }
}

#package Grant;
# ####################################
# FINDING THE RIGHT GRANT-RULE
# ==========================================================
# sub Get_grant_from_db:
# ==========================================================
sub Get_grant_from_db {
  my ($host,$db,$user) = @_;
  print "Get_grant_from_db(): \n" if ($DEBUG>0);
  my %Access_db    = %{Default_Access_Rights()};
  my $process_host_table=0;
  my $rule_found=0;
  $Rules{'db'} = 'no_rule_found';

  foreach $record (@sorted_db_table) {
    $full_access=0;
    print "Read db: $record\n" if ($DEBUG>2);
    #chop($record);
    @record=split(/\t/,$record);

    # check host and db
    # with possible wildcards in field
    # replace mysql-wildcards by reg-wildcards
    my $host_tpl = SQL2Reg($record[0]);
    my $db_tpl   = SQL2Reg($record[1]);
    my $user_tpl = $record[2]; #user field isn't pattern matched!!
    print "\thost_tpl : $record[0] => $host_tpl\n" if ($DEBUG>1);
    print "\tdb_tpl   : $record[1] => $db_tpl\n" if ($DEBUG>1);
    print "\tuser_tpl : $record[2] => $user_tpl\n" if ($DEBUG>1);
    if ($DEBUG>2) {
      if ( Is_localhost($host_tpl)
           or  MatchTemplate($host_tpl,$host_name)
           or  MatchTemplate($host_tpl,$host_ip) )
        { print "\t* host  [$host_name,$host_ip] matched with rule [$host_tpl]\n"; }
      else			   { print "\t* host [$host_name,$host_ip] doesn't match\n"; }
      if ( MatchTemplate($db_tpl,$db) )
        { print "\t* db [$db] matched with rule [$db_tpl]\n"; }
      else                       { print "\t* db [$db] doesn't match\n";}
      if ( MatchTemplate($user_tpl,$user) )
        { print "\t* user  [$user] matched with rule [$user_tpl]\n"; }
      else                       { print "\t* user [$user] doesn't match\n"; }
    }

    if ( ( Is_localhost($host_tpl)
           or  MatchTemplate($host_tpl,$host_name)
           or  MatchTemplate($host_tpl,$host_ip) )
         and ( MatchTemplate($db_tpl,$db) )
         and ( MatchTemplate($user_tpl,$user) ) ) {
 
      $process_host_table = ($record[0] eq '');

      if ($user_tpl eq '') { push(@Warnings,'public_database'); }

      foreach $field (keys(%D)) {
        printf "\t> %-15s: input=$record[$D{$field}]  =>  $Access{$field}($Answer{$Access_db{$field}}) -> ",$field if ($DEBUG>1);
        $Access_db{$field} = ($Access_db{$field} or $Answer{$record[$D{$field}]});
        print "$Access_db{$field}($Answer{$Access_db{$field}})\n" if ($DEBUG>1);
      }
      print "\n" if ($DEBUG>1);
      $rule_found=1;
      $Rules{'db'} = $record;
      last;
    }
  }

  # -------------------------------
  #  setting privileges to db-priv
  print "Rights after parsing db-table..:\n" if ($DEBUG>1);
  if (! $rule_found ) {
    print "NO rule found in db-table => no access granted!!\n" if ($DEBUG>1);
    #foreach $field (keys(%Access_db)) { $Access_db{$field} = 1; }
    #push(@Notes,'insecure_db');
  }
  foreach $field (keys(%Access)) {
      $Access{$field} = ($Access{$field} or $Access_db{$field});
  }
  #push(@Notes,'least_priv');

  # --------------------------------
  # debugging access-rights in db 
  Print_Access_rights(\%Access) if ($DEBUG>1);

  return $process_host_table;
}

# ==========================================================
# sub Get_grant_from_host:
# ==========================================================
sub Get_grant_from_host {
  my ($host,$db) = @_;
  print "Get_grant_from_host()\n" if ($main::DEBUG>0);
  my %Access_host = %{Default_Access_Rights()};
  my $rule_found=0;
  my @record = ();
  $Rules{'host'} = 'no_rule_found';

  # the host-table doesn't have to be processed if the host-field
  # in the db-table isn't empty
  if (!$process_host_table) {
    print ">> Host-table doesn't have to be processed!!\n" if ($main::DEBUG>1);
    $Rules{'host'} = 'no_equiv_host';
    return 1;
  }

  foreach $record (@main::sorted_host_table) {
    $full_access=0;
    print "host: $record" if ($main::DEBUG>2);
    #chop($record);
    @record=split(/\t/,$record);

    # check host and db
    # with possible wildcards in field
    # replace mysql-wildcards by reg-wildcards
    my $host_tpl = SQL2Reg($record[0]);
    my $db_tpl   = SQL2Reg($record[1]);
    print "\thost_tpl : $record[0] -> $host_tpl\n" if ($main::DEBUG>2);
    print "\tdb_tpl   : $record[1] -> $db_tpl\n" if ($main::DEBUG>2);

    if ($DEBUG>2) {
      if ( Is_localhost($host_tpl)
           or MatchTemplate($host_tpl,$host_name)
           or MatchTemplate($host_tpl,$host_ip) )
        { print "\t* host [$host_name,$host_ip] matched with rule [$host_tpl]\n"; }
      else
        { print "\t* host doesn't match\n"; }
      if ( MatchTemplate($db_tpl,$db) )
        { print "\t* db [$db] matched with rule [$db_tpl]\n"; }
      else
        { print "\t* db doesn't match \n";}
    }

    if ( ( Is_localhost($host_tpl)
           or MatchTemplate($host_tpl,$host_name)
           or MatchTemplate($host_tpl,$host_ip) )
         and ( MatchTemplate($db_tpl,$db) ) ) {

      $Rules{'host'} = $record;
      $rule_found=1;
      foreach $field (keys(%H)) {
        printf "\t> %-15s: input=$record[$H{$field}]  =>  $Access_host{$field}($Answer{$Access_host{$field}}) -> ",$field if ($DEBUG>2);
        $Access_host{$field} = ($Access_host{$field} or $Answer{$record[$H{$field}]});
        print "$Access_host{$field}($Answer{$Access_host{$field}})\n" if ($main::DEBUG>2);
      }
      print "\n" if ($main::DEBUG>2);
      last;
    }
  }

  # -------------------------------
  #  setting privileges to host-priv
  print "Rights after parsing host-table..:\n" if ($main::DEBUG>2);
  if (! $rule_found ) {
     @record=();
     print "NO restrictions found in the host-table!!\n" if ($main::DEBUG>1);
  }
  foreach $field (keys(%Access)) {
      $Access{$field} = ($Access_host{$field} and $Access{$field});
  }

  # --------------------------------
  # debugging access-rights in db 
  Print_Access_rights(\%Access) if ($DEBUG>1);

  return @record; #matching record in host-table
}

# ==========================================================
# sub Get_grant_from_user:
# ==========================================================
sub Get_grant_from_user {
  my ($host,$user) = @_;
  print "Debug Get_grant_from_user: \n" if ($DEBUG>0);
  my %Access_user = %{Default_Access_Rights()};
  my $rule_found=0;
  my @record = ();
  $Rules{'user'} = 'no_rule_found';

  foreach $record (@main::sorted_user_table) {
    $full_access=0;
    print "user: $record" if ($DEBUG);
    #chop($record);
    @record=split(/\t/,$record);

    # check host and db
    # with possible wildcards in field
    # replace mysql-wildcards by reg-wildcards
    my $host_tpl = SQL2Reg($record[0]);
    my $user_tpl = $record[1]; #user field isn't pattern-matched!!
    my $passwd   = $record[2];
    print "\thost_tpl : $record[0] -> $host_tpl\n" if ($DEBUG>1);
    print "\tuser_tpl : $record[1] -> $user_tpl\n" if ($DEBUG>1);
    print "\tpassword : $record[2] -> $passwd\n" if ($DEBUG>1);

    if ($DEBUG>1) {
      if ( Is_localhost($host_tpl)
           or MatchTemplate($host_tpl,$host_name)
           or MatchTemplate($host_tpl,$host_ip) )
        { print "\t* host  [$host_name,$host_ip] matched with rule [$host_tpl]\n"; }
      else
        { print "\t* host doesn't match\n"; }
      if ( MatchTemplate($user_tpl,$user) )
        { print "\t* user  [$user] matched with rule [$user_tpl]\n"; }
      else
        { print "\t* user doesn't match\n"; }
      if ($passwd ne "" )
        { print "\tPassword required\n"; }
      else
        { print "\tNo password required\n"; }
    }

    if ( ( Is_localhost($host_tpl)
           or  MatchTemplate($host_tpl,$host_name)
           or  MatchTemplate($host_tpl,$host_ip) )
         and ( MatchTemplate($user_tpl,$user) ) ) {

      if ($passwd eq '') { push(@Warnings,'insecure_user');  }
      else               { push(@Notes,'password_required'); }

      foreach $field (keys(%U)) {
        printf "\t> %-15s: input=$record[$U{$field}]  =>  $Access_user{$field}($Answer{$Access_user{$field}}) -> ",$field if $DEBUG;
        $Access_user{$field} = ($Access_user{$field} or $Answer{$record[$U{$field}]});
        print "$Access_user{$field}($Answer{$Access_user{$field}})\n" if $DEBUG;
      }
      print "\n" if $DEBUG;
      $Rules{'user'} = $record;
      $rule_found=1;
      last;
    }
  }

  # -------------------------------
  #  setting privileges to user-priv
  print "Rights after parsing user-table..:\n" if ($DEBUG>1);
  if (! $rule_found ) {
     @record=();
     print "NO record found in the user-table!!\n" if ($DEBUG>1);
  }
  foreach $field (keys(%Access)) {
    $Access{$field} = ($Access_user{$field} or $Access{$field});
  }
 
  # --------------------------------
  # debugging access-rights in db   
  print "Rights after parsing user-table..:\n" if ($DEBUG>1);
  Print_Access_rights(\%Access) if ($DEBUG>1);

  print "returning @record" if ($DEBUG>1);
  return @record; #matching record in user-table
}
# ===========================================================
# sub Default_Access_Rights():
#  return (a reference to) a hash which holds all default
#  priviliges currently defined in the grant-tables.
# ===========================================================
sub Default_Access_Rights {
    my %right = ();
    print "Debug Default_Access_Rights():\n" if ($DEBUG>1);
    # add entry for all fields in the HOST-table
    foreach $field (keys(%main::H)) {
	$right{$field}='0' unless (defined($right{$field}));
    }
    # add entry for all fields in the DB-table
    foreach $field (keys(%main::D)) {
	$right{$field}='0' unless (defined($right{$field}));
    }
    # add entry for all fields in the USER-table
    foreach $field (keys(%main::U)) {
	$right{$field}='0' unless (defined($right{$field}));
    }
    if ($main::DEBUG>2) {
       foreach $field (keys(%right)) { print "> $field : $right{$field}\n"; }
    }
    return \%right;
}

# ======================================
# sub Make_Privlist
#  Make an ordered list of the privileges
#  that should be reported
# ======================================
sub Make_Privlist {
    # layout:
    #'select_priv',     'create_priv',
    #'insert_priv',     'drop_priv',
    #'update_priv',     'reload_priv',
    #'delete_priv',     'process_priv',
    #'file_priv',       'shutdown_priv');
    my $right;
    my @privlist=();
    foreach $right (@main::U) {
	if (! grep(/$right/,@privlist)) { push(@privlist,$right); }
    };
    foreach $right (@main::D) {
	if (! grep(/$right/,@privlist)) { push(@privlist,$right); }
    };
    foreach $right (@main::H) {
	if (! grep(/$right/,@privlist)) { push(@privlist,$right); }
    };
    if ($main::DEBUG>2) {
       print "Privileges:\n";
       foreach $field (@privlist) { print " > $field\n"; }
    }
    return \@privlist;
}
